## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----example------------------------------------------------------------------
library(ergmito)
data(fivenets)
model_object <- ergmito_formulae(fivenets ~ edges + ttriad)

# Printing the model object
model_object

# Printing the log-likelihood function
model_object$loglik

## ----looking-at-the-components------------------------------------------------
# The vectors of weights
str(model_object$stats_weights)

# The matrices of the sufficient statistics
str(model_object$stats_statmat)

# The target statistic
model_object$target_stats

## -----------------------------------------------------------------------------
# Analyzing the model
model_object <- ergmito_formulae(fivenets ~ edges + nodematch("female")) 

# Defining the logposterior
logposterior <- function(p) {
  model_object$loglik(params = p) + 
  sum(dnorm(p, mean = c(-1,1), sd = sqrt(2), log = TRUE))
}
 

## -----------------------------------------------------------------------------
# Loading the required R packages
library(fmcmc)
library(coda)

# Is it working?
logposterior(c(-1, 1))

# Now, calling the MCMC function from the fmcmc R package
ans <- MCMC(
  fun     = logposterior,
  initial = c(0, 0),
  # 5,000 steps sampling one of every ten iterations
  nsteps  = 5000,
  thin    = 10,
  # We are using a normal transition kernel with .5 scale and updates are done
  # one variable at a time in a random order
  kernel = kernel_normal(scale = .5, scheme = "random")
  )

## ----looking-at-the-output, fig.height=7, fig.width=7-------------------------
plot(ans)
summary(ans)

## -----------------------------------------------------------------------------
summary(ergmito(fivenets ~ edges + nodematch("female")))

## ----fivenets-cycle5----------------------------------------------------------
library(ergmito)
data(fivenets)
(ans <- ergmito(fivenets ~ edges + triadcensus(15)))

## ----fivenets-ll--------------------------------------------------------------
# Approach using the limiting value
l <- with(ans$formulae, {
  sapply(1:nnets(ans), function(i) {
    # Preparing suff stats
    S <- t(t(stats_statmat[[i]]) - target_stats[i, ])
    W <- stats_weights[[i]]
    theta <- coef(ans)["edges"]
    
    # Index of members of S0
    s0idx <- which(S[,2] == 0)
    
    - log(sum(W[s0idx] * exp(S[s0idx,1] * theta)))
  })
})
sum(l)

# Which should be equivalent to the approach with large negative number
ans$formulae$loglik(c(coef(ans)["edges"], -1e100))

## ----grad-fivenets------------------------------------------------------------
g <- with(ans$formulae, {
  sapply(1:nnets(ans), function(i) {
    # Preparing suff stats
    S <- t(t(stats_statmat[[i]]) - target_stats[i, ])
    W <- stats_weights[[i]]
    theta <- coef(ans)["edges"]
    
    # Index of members of S0
    s0idx <- which(S[,2] == 0)
    
    - sum(W[s0idx] * S[s0idx,1] * exp(S[s0idx,1] * theta))/
      sum(W[s0idx] * exp(S[s0idx,1] * theta))
  })
})
sum(g)

# Which is equivalent to
ans$formulae$grad(c(coef(ans)["edges"], -1e100))

## ----hess-fivenets------------------------------------------------------------
h <- with(ans$formulae, {
  sapply(1:nnets(ans), function(i) {
    # Preparing suff stats
    S <- t(t(stats_statmat[[i]]) - target_stats[i, ])
    W <- stats_weights[[i]]
    theta <- coef(ans)["edges"]
    
    # Index of members of S0
    s0idx <- which(S[,2] == 0)
    
    # First part
    - sum(W[s0idx] * S[s0idx,1]^2 * exp(S[s0idx,1] * theta))/
      sum(W[s0idx] * exp(S[s0idx,1] * theta)) + 
      # Second bit
      sum(W[s0idx] * S[s0idx,1] * exp(S[s0idx,1] * theta)) ^ 2/
      sum(W[s0idx] * exp(S[s0idx,1] * theta))^2
  })
})
sum(h)

## ----hessian2-----------------------------------------------------------------
ans$formulae$hess(c(coef(ans)["edges"], -1e100))

# Single network test
set.seed(4532)
nets <- rbernoulli(8)

expect_error(new_rergmito(nets ~ edges, theta = -1, force = FALSE), "force")

set.seed(4532)
nets <- rbernoulli(3)

expect_error(new_rergmito(
  list(nets, network::network(nets, directed = FALSE)) ~ edges, "mix"
))

Sys.unsetenv("ERGMITO_TEST")
set.seed(1);ans0 <- new_rergmito(nets ~ edges + mutual, theta=c(-.5, .5))
Sys.setenv(ERGMITO_TEST = 1)
set.seed(1);ans1 <- new_rergmito(nets ~ edges + mutual, theta=c(-.5, .5), force = TRUE)

expect_equal(ans0$prob, ans1$prob)
expect_equal(sum(ans0$probabilities), 1)

# Multiple network
set.seed(45532)
nets <- rbernoulli(c(3,3,3))

Sys.unsetenv("ERGMITO_TEST")
set.seed(1);ans0 <- new_rergmito(nets ~ edges + mutual, theta = c(-.5, .5))
Sys.setenv(ERGMITO_TEST = 1)
set.seed(1);ans1 <- new_rergmito(nets ~ edges + mutual, theta = c(-.5, .5), force = TRUE)

expect_equal(ans0[[1]]$probabilities, ans1[[1]]$probabilities)
expect_equal(sum(ans0[[1]]$probabilities), 1)

# Multiple sizes
Sys.unsetenv("ERGMITO_TEST")
set.seed(45532)
nets <- rbernoulli(c(3,4))
set.seed(1);ans0 <- new_rergmito(nets ~ edges + mutual, theta=c(-.5,.5))
Sys.setenv(ERGMITO_TEST = 1)

expect_equal(sum(ans0[[1]]$probabilities), 1)
expect_equal(sum(ans0[[2]]$probabilities), 1)

# Sampler with the data
data("fivenets")
mod <- ergmito(fivenets ~ edges + nodematch("female"))
network::delete.vertices(fivenets[[1]], 1)

Sys.unsetenv("ERGMITO_TEST")
ans0 <- new_rergmito(fivenets[[1]] ~ edges + nodematch("female"), theta = coef(mod))
Sys.setenv(ERGMITO_TEST = 1)
ans1 <- new_rergmito(fivenets[[1]] ~ edges + nodematch("female"), theta = coef(mod), force = TRUE)
Sys.unsetenv("ERGMITO_TEST")

expect_equal(ans0$probabilities, ans1$probabilities)
expect_equal(sum(ans0$probabilities), 1)
  

set.seed(4532)
nets <- rbernoulli(3)
ans  <- new_rergmito(nets ~ edges + mutual, theta = c(-.5, .5))

expect_output(print(ans), "ERGMito simulator")
expect_output(print(str(ans)), "language new_rergmito")
expect_equal(ans$get_networks(), powerset(3))
expect_equal(ans$get_networks(), ans[])

Sys.unsetenv("ERGMITO_TEST")


# Undirected networks ----------------------------------------------------------
set.seed(554)
nets <- rbernoulli(4, .1)
nets <- network::network(nets, directed = FALSE)
ans <- ergmito(nets ~ edges + triangles)
coef_ans <- coef(ans)
ans  <- suppressWarnings(
  new_rergmito(
    nets ~ edges + triangles, force = TRUE,
    theta = coef_ans
    ))

expect_length(ans$networks, 2^(4*3/2))
expect_equal(
  as_adjmat(ans$get_networks()),
  powerset(4, directed = FALSE)
  )
expect_equal(sum(ans$probabilities), 1)

# Directed powersets -----------------------------------------------------------
pset2 <- powerset(2, directed = TRUE)
pset3 <- powerset(3, directed = TRUE)
pset4 <- powerset(4, directed = TRUE)
pset5 <- powerset(5, directed = TRUE)

expect_length(pset2, 4)
expect_length(pset3, 2^6)
expect_length(pset4, 2^(4*3))
expect_length(pset5, 2^(5*4))

net <- network::network(rbernoulli(3), directed = TRUE)

# Computing using powersets
pset <- powerset(3, directed = TRUE, force = TRUE)
ans1 <- lapply(pset, function(i) {
  summary(i ~ edges + mutual)
})

ans1 <- do.call(rbind, ans1)
ans1 <- table(paste0(ans1[,1], ans1[,2]))
ans1 <- structure(as.vector(ans1), names = names(ans1))
ans1 <- ans1[order(names(ans1))]

# Baseline
ans0 <- ergm::ergm.allstats(net ~ edges + mutual, zeroobs = FALSE)
ans0 <- with(
  ans0,
  structure(weights, names = paste0(statmat[,1], statmat[,2]))
)
ans0 <- ans0[order(names(ans0))]

expect_equal(ans0, ans1)  

# Undirected powersets ---------------------------------------------------------
pset2 <- powerset(2, directed = FALSE)
pset3 <- powerset(3, directed = FALSE)
pset4 <- powerset(4, directed = FALSE)
pset5 <- powerset(5, directed = FALSE)

expect_length(pset2, 2)
expect_length(pset3, 2^(6/2))
expect_length(pset4, 2^(4*3/2))
expect_length(pset5, 2^(5*4/2)) 

net <- network::network(rbernoulli(4), directed = FALSE)

# Computing using powersets
pset <- powerset(4, directed = FALSE, force = TRUE)
pset <- lapply(pset, network::network, directed = FALSE)
ans1 <- lapply(pset, function(i) {
  summary(i ~ edges + cycle(3))
})

ans1 <- do.call(rbind, ans1)
ans1 <- table(paste0(ans1[,1], ans1[,2]))
ans1 <- structure(as.vector(ans1), names = names(ans1))
ans1 <- ans1[order(names(ans1))]

# Baseline
ans0 <- ergm::ergm.allstats(net ~ edges + cycle(3), zeroobs = FALSE)
ans0 <- with(
  ans0,
  structure(weights, names = paste0(statmat[,1], statmat[,2]))
  )
ans0 <- ans0[order(names(ans0))]

expect_equal(ans0, ans1)  

# Generating the data
params <- c(.5, .8)
nets   <- powerset(3)

# Computing statistics per network
stats <- lapply(nets, function(n) {
  
  ergm::summary_formula(n ~ edges + mutual)
  
})
stats <- do.call(rbind, stats)

# Summary statistics
allstats <- ergm::ergm.allstats(nets[[1]] ~ edges + mutual, zeroobs = FALSE)

# Function to compute the loglike of all networks
ergmloglik <- function(x) {
  
  apply(x, 1, function(z) {
    
    ergmito:::exact_loglik2(params, z, allstats)
    
  })
  
}

ans0 <- ergmloglik(stats)
ans1 <- exact_loglik(stats, params, allstats$weights, allstats$statmat)

expect_equal(sum(exp(ans0)), 1, tol = 1e-5)
expect_equal(sum(exp(ans1)), 1, tol = 1e-5)

expect_equivalent(ans0[], ans1[])
  

# # Are these equal
# all(parloglik(stats) ==
#       exact_ll(stats, params, allstats$weights, allstats$statmat))

# Fully connected network
x <- rbernoulli(c(4,4,4), 1)
ans0 <- ergmito(x ~ edges + ttriad)

# Very high density
x <- lapply(x, function(x.) {
  x.[2] <- 0L
  x.
})
ans0b <- ergmito(x ~ edges + ttriad)
ans0b$formulae$loglik(c(1e3, coef(ans0b)[2]))

# Empty graph
x <- rbernoulli(c(4,4,4), 0)
ans1 <- ergmito(x ~ edges + ttriad)

# Very low density
x <- lapply(x, function(x.) {
  x.[2:3] <- 1L
  x.
})
ans2 <- ergmito(x ~ edges + ttriad)

expect_true(all(is.infinite(coef(ans0))))
expect_true(all(coef(ans1) < 0) & all(is.infinite(coef(ans1))))
expect_true(coef(ans2)[2] < 0 & is.infinite(coef(ans2)[2]))
expect_equal(summary(ans0)$coefs[, "Pr(>|z|)"], c(0, 0), tol = 1e-2)
expect_equal(summary(ans1)$coefs[, "Pr(>|z|)"], c(0, 0), tol = 1e-2)
expect_equal(summary(ans2)$coefs[, "Pr(>|z|)"], c(0, 0), tol = 1e-2)

pretty_printer <- function(x) {
  paste(
    "\n",
    paste(capture.output(eval(x)), collapse = "\n"),
    "\n"
  )
}

message(
  "\nOn some OSs these are not easy to test. So here is the expected results:\n",
  pretty_printer(summary(ans0)), "\n----- should be c(Inf, Inf) \n----- with pval 0.\n",
  pretty_printer(summary(ans1)), "\n----- should be -c(Inf, Inf), \n----- with pval 0.\n",
  pretty_printer(summary(ans2)), "\n----- should be -Inf (2nd) \n----- with pval 0."
  )
  

data("fivenets")
net0 <- fivenets
net0[[4]] <- USArrests

expect_error(ergmito_formulae(net0 ~ edges), "not a matrix")
expect_error(ergmito_formulae(USArrests ~ edges), "networks or a single")
  

data("fivenets")
ans <- ergmito(fivenets ~ edges)
expect_error(exact_loglik(
  x             = ans$formulae$target_stats,
  params        = ans$coef,
  stats_weights = ans$formulae$stats_weights[-2],
  stats_statmat = ans$formulae$stats_statmat 
  ), "should be numeric"
)

expect_error(exact_loglik(
  x             = ans$formulae$target_stats,
  params        = ans$coef,
  stats_weights = ans$formulae$stats_weights,
  stats_statmat = ans$formulae$stats_statmat[-2] 
), "should be matrix"
)

expect_error(exact_loglik(
  x             = ans$formulae$target_stats[-(1:5),,drop=FALSE],
  params        = ans$coef,
  stats_weights = ans$formulae$stats_weights,
  stats_statmat = ans$formulae$stats_statmat 
), "greater than 0"
)


ans0 <- ans$formulae$grad(params = ans$coef)
expect_equal(ans0[1], 0.0, tol=1e-5)

data(fivenets)
ans <- ergmito(fivenets ~ edges + mutual + ttriad)

ans0 <- ans$formulae$grad(params = rep(0, length(coef(ans))))
ans1 <- exact_gradient(
  x = ans$formulae$target_stats,
  params        = rep(0, length(coef(ans))),
  stats_weights = ans$formulae$stats_weights,
  stats_statmat = ans$formulae$stats_statmat
)

expect_equal(ans0, ans1)

# Checking offset terms -----------------------------------
data(fivenets)

m0 <- ergmito_formulae(fivenets ~ edges + ttriad, model_update = ~ . + offset(edges))
m1 <- ergmito_formulae(fivenets ~ edges + ttriad, model_update = ~ . + I(edges))

expect_equal(
  m0$loglik(c(.5, .5)),
  m1$loglik(c(.5, .5, 1))
)

expect_equal(
  m0$grad(c(.5, .5)),
  m1$grad(c(.5, .5, 1))[-3,,drop=FALSE]
)

pset <- powerset(4)

# List method
ans0 <- matrix_to_network(pset)
ans1 <- lapply(pset, network::as.network)

expect_equal(as_adjmat(ans0), as_adjmat(ans1))

expect_equal(
  as_adjmat(matrix_to_network(pset[[106]])),
  as_adjmat(network::as.network(pset[[106]]))
  )

data(sampson, package="ergm")
data(faux.desert.high, package="ergm")

expect_equivalent(as_adjmat(samplike), as.matrix(samplike))
expect_equivalent(as_adjmat(faux.desert.high), as.matrix(faux.desert.high))

# Checking which are directed or undirected
set.seed(713)
nets <- rbernoulli(c(4,4,4))
nets0 <- lapply(nets, network::network, directed = FALSE)
nets1 <- lapply(nets, network::network, directed = TRUE)
expect_equal(is_directed(nets0), rep(FALSE, 3))
expect_equal(is_directed(nets1), rep(TRUE, 3))
expect_true(!is_directed(nets0[[1]]))
expect_true(is_directed(nets0[[1]][1:4,1:4]))
expect_error(is_directed(nets0[[1]][1:4,1:4], check_type = TRUE))

# Generating data
x <- powerset(5)
ans0 <- count_stats(x[1:100], c("mutual", "edges"))

# Calculating using summary_formula
ans1 <- lapply(x[1:100], function(i) {
  ergm::summary_formula(i ~ mutual + edges)
})
ans1 <- do.call(rbind, ans1)

expect_equivalent(ans0, ans1)

# Matches the formula syntax
ans2 <- count_stats(x[1:100] ~ mutual + edges)
expect_equivalent(ans0, ans2)
  

data(fivenets)
ans0 <- geodesita(fivenets)
ans1 <- lapply(fivenets, sna::geodist, inf.replace = NA_integer_)
ans1 <- lapply(ans1, "[[", "gdist")

# On the fivenets
expect_equal(ans0, ans1)

# On powerset of 4
pset <- powerset(4)
ans0 <- geodesita(pset)
ans1 <- lapply(pset, sna::geodist, inf.replace = NA_integer_)
ans1 <- lapply(ans1, "[[", "gdist")
expect_equal(ans0, ans1)

# Small matrices
ans0 <- geodesita(pset[[2]])
ans1 <- sna::geodist(pset[[2]], inf.replace = NA_integer_)$gdist
ans2 <- geodesita(network::as.network(pset[[2]]))
expect_equal(ans0[[1]], ans1)
expect_equal(ans0, ans2)


# Bug in ergm?????? ----------------------------------------------------------
set.seed(1)
pset3 <- powerset(3) # rbernoulli(rep(6, 100))
ans0 <- count_stats(pset3, c("ttriad"))[,1]
ans1 <- unname(sapply(pset3, function(p) summary(p ~ ttriad)))

expect_equivalent(ans0, ans1)
#-----------------------------------------------------------------------------

estats <- c(
  `mutual`          = "mutual",
  `edges`           = "edges",
  `ctriad`          = "ctriad",
  `ttriad`          = "ttriad",
  `triangle`        = "triangle",
  `balance`         = "balance",
  `triadcensus(15)` = "t300",
  `triadcensus(2)`  = "t102",
  `idegree1.5`      = "idegree1.5",
  `odegree1.5`      = "odegree1.5"
)

for (s in seq_along(estats)) {
  ans0 <- count_stats(pset3, c(estats[s]))[,1]
  ans1 <- unname(sapply(pset3, function(p) {
    summary(as.formula(paste0("p ~ ", names(estats)[s])))
    }))
  
  expect_equivalent(ans0, ans1)
}

pset5 <- powerset(5)
pset5 <- pset5[order(sapply(pset5, sum))]
pset5 <- c(head(pset5, 25), tail(pset5, 25))
for (star in c("istar", "ostar"))
for (i in 1:4) {
  ans0 <- count_stats(pset5, paste0(star, i))[,1]
  ans1 <- unname(sapply(pset5, function(p) {
    ergm::summary_formula(as.formula(paste0("p ~ ",star, "(", i, ")")))
    }))
  
  expect_equivalent(ans0, ans1)
}


# Attribute based ------------------------------------------------------------
set.seed(44)
age <- lapply(nvertex(pset5), rpois, lambda=4)

ans0 <- count_stats(pset5, "nodeocov", age)
ans1 <- unname(sapply(seq_along(pset5), function(i) {
  ergm::summary_formula(network::network(pset5[[i]], list(age = age[[i]]), "age") ~ nodeocov("age"))
  }))

expect_equivalent(as.vector(ans0), as.vector(ans1))

ans0 <- count_stats(pset5, "nodeicov", age)
ans1 <- unname(sapply(seq_along(pset5), function(i) {
  ergm::summary_formula(network::network(pset5[[i]], list(age = age[[i]]), "age") ~ nodeicov("age"))
}))

expect_equivalent(as.vector(ans0), as.vector(ans1))

ans0 <- count_stats(pset5, "absdiff", age)
ans1 <- unname(sapply(seq_along(pset5), function(i) {
  ergm::summary_formula(network::network(pset5[[i]], list(age = age[[i]]), "age") ~ absdiff("age"))
}))

expect_equivalent(as.vector(ans0), as.vector(ans1))

for (star in c("istar", "ostar"))
  for (i in 1:4) {
    ans0 <- as.vector(count_stats(pset5, paste0(star, i), age))
    ans1 <- integer(length(pset5))
    for (g in seq_along(pset5)) {
      net <- network::network(pset5[[g]], list(age = age[[g]]), "age")
      fm <- as.formula(paste0("net ~ ", star, "(",i, ", attr=\"age\")"))

      ans1[g] <- summary(fm)
    }

    expect_equivalent(ans0, ans1)
  }




# network(pset3[[1]], list(age = age[[1]])) %>%
#           gplot(label = age[[1]])
  
data("fivenets")
expect_error(
  ergmito(fivenets ~ edges + edgecitos),
  "not found"
)

expect_error(analyze_formula())

# Error when analyzing undirected networks
expect_error(
  count_stats(
    network::network(rbernoulli(4), directed = FALSE) ~ edges
    ), "undirected"
  )

# Not available
expect_error(count_stats(rbernoulli(4) ~ missing_term), "not available")

# test_that("boot works", {
  
data(fivenets, package="ergmito")
ans0 <- ergmito(fivenets ~ edges + nodematch("female"))
ans1 <- suppressWarnings(ergmito_boot(ans0, R = 200L, ncpus = 1L))
ans2 <- suppressWarnings(ergmito_boot(ans0, R = 200L, ncpus = 2L))

expect_output(print(ans1), "200 replicates")
expect_output(print(ans2), "200 replicates")
#   
# })

---
title: "Extending ergmito"
author: "George G. Vega Yon"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Extending ergmito}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

The `ergmito`'s workhorse are two other functions: (1) `ergm`'s `ergm.allstats`
which is used to compute the support of model's sufficient statistics, and (2)
`ergmito_formulae` which is a wrapper of that same function, and that returns a
list including the following two functions: `loglike` and `grad`, the functions
to calculate the joint log-likelihood of the model and its gradient.

```{r example}
library(ergmito)
data(fivenets)
model_object <- ergmito_formulae(fivenets ~ edges + ttriad)

# Printing the model object
model_object

# Printing the log-likelihood function
model_object$loglik
```

Besides of the log-likelihood function and the gradient function,
`ergmito_formulae` also returns We can take a look at each component from our previous object:

```{r looking-at-the-components}
# The vectors of weights
str(model_object$stats_weights)

# The matrices of the sufficient statistics
str(model_object$stats_statmat)

# The target statistic
model_object$target_stats
```

All this is closely related to the output object from the function `ergm.allstats`.
The next section shows how all this works together to estimate the model parameters
using Metropolis-Hastings MCMC.

# Example: Bayesian inference with fivenets

Suppose that we have a prior regarding the distribution of the `fivenets` model:
The `edges` parameter is normally distributed with mean -1 and variance 2, while
the `nodematch("female")` term has the same distribution but with mean 1. We can
implement this model using a Metropolis-Hastings ratio. First, we need to define
the log of the posterior distribution:

```{r}
# Analyzing the model
model_object <- ergmito_formulae(fivenets ~ edges + nodematch("female")) 

# Defining the logposterior
logposterior <- function(p) {
  model_object$loglik(params = p) + 
  sum(dnorm(p, mean = c(-1,1), sd = sqrt(2), log = TRUE))
}
 
```

For this example, we are using the fmcmc R package. Here is how we put
everything together:

```{r}
# Loading the required R packages
library(fmcmc)
library(coda)

# Is it working?
logposterior(c(-1, 1))

# Now, calling the MCMC function from the fmcmc R package
ans <- MCMC(
  fun     = logposterior,
  initial = c(0, 0),
  # 5,000 steps sampling one of every ten iterations
  nsteps  = 5000,
  thin    = 10,
  # We are using a normal transition kernel with .5 scale and updates are done
  # one variable at a time in a random order
  kernel = kernel_normal(scale = .5, scheme = "random")
  )
```

We can now visualize our results. Since the resulting object is of class `mcmc.list`,
which is implemented in the `coda` R package for MCMC diagnostics, we can use
all the methods included in the package:

```{r looking-at-the-output, fig.height=7, fig.width=7}
plot(ans)
summary(ans)
```

Finally, we can compare this result with what we obtain from the `ergmito` function

```{r}
summary(ergmito(fivenets ~ edges + nodematch("female")))
```
